You're viewing an archived version of our docs. Check out our current documentation →
InstantSearch / Angular / V4 / API reference

Ais-Instantsearch | Angular InstantSearch V4 (Deprecated)

Deprecated content
Angular InstantSearch is deprecated. Please use InstantSearch.js instead. For more information, see Migrating from Angular InstantSearch.

Signature

Signature
<ais-instantsearch
  [config]="{
    indexName: string
    searchClient: object
    // Optional parameters
    numberLocale: string
    searchFunction: function
    initialUiState: object
    onStateChange: function
    stalledSearchDelay: number
    routing: boolean|object
    insightsClient: function
  }"
></ais-instantsearch>

Import

1
2
3
4
5
6
7
8
import { NgAisInstantSearchModule } from 'angular-instantsearch';

@NgModule({
  imports: [
    NgAisInstantSearchModule.forRoot(),
  ],
})
export class AppModule {}

1. Follow additional steps in Optimize build size to ensure your code is correctly bundled.
2. This imports all the widgets, even the ones you don’t use. Read the Getting started guide for more information.

About this widget

The ais-instantsearch widget is a wrapper that allows you to configure your search. It provides the search state to all its children.

You must wrap all other Angular InstantSearch widgets inside this one.

Examples

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
import { liteClient as algoliasearch } from 'algoliasearch/lite';

@Component({
  template: `
    <ais-instantsearch [config]="config">
      <!-- Widgets -->
    </ais-instantsearch>
  `,
})
export class AppComponent {
  config = {
    indexName: 'instant_search',
    searchClient: algoliasearch('YourApplicationID', 'YourSearchOnlyAPIKey'),
  }
}

Props

indexName

Required
Type: string

The main index in which to search.

1
2
3
4
5
6
7
8
9
10
11
12
13
@Component({
  template: `
    <ais-instantsearch [config]="config">
      <!-- Widgets -->
    </ais-instantsearch>
  `,
})
export class AppComponent {
  config = {
    // ...
    indexName: 'instant_search',
  }
}

searchClient

Required
Type: object

Provides a search client to ais-instantsearch. Read the custom backend guidance on implementing a custom search client.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
import { liteClient as algoliasearch } from 'algoliasearch/lite';

@Component({
  template: `
    <ais-instantsearch [config]="config">
      <!-- Widgets -->
    </ais-instantsearch>
  `,
})
export class AppComponent {
  config = {
    // ...
    searchClient: algoliasearch(
      'YourApplicationID',
      'YourSearchOnlyAPIKey'
    ),
  }
}

numberLocale

Optional
Type: string

The locale used to display numbers. This is passed to .toLocaleString().

1
2
3
4
5
6
7
8
9
10
11
12
13
@Component({
  template: `
    <ais-instantsearch [config]="config">
      <!-- Widgets -->
    </ais-instantsearch>
  `,
})
export class AppComponent {
  config = {
    // ...
    numberLocale: 'fr',
  }
}

searchFunction

Optional
Type: function

This option allows you to take control of search behavior. For example, to avoid doing searches at page load.

When this option is set, search.helper won’t emit events. Instead, use on-state-change or widgets to handle search behavior.

A hook is called each time a search is requested (with Algolia’s helper API as a parameter). Carry out the search by calling helper.search().

When modifying the state of the helper within search-function, the helper resets the page to 0. If you want to keep the current page, you need to store the information about the page, modify the state and reapply the pagination.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
@Component({
  template: `
    <ais-instantsearch [config]="config">
      <!-- Widgets -->
    </ais-instantsearch>
  `,
})
export class AppComponent {
  config = {
    // ...
    searchFunction(helper) {
      helper.search();
    }
  }
}

initialUiState

Optional
Type: object

Adds a ui-state to your instantsearch instance, which provides an initial state to your widgets.

Replace YourIndexName with the name of your Algolia index.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
@Component({
  template: `
    <ais-instantsearch [config]="config">
      <!-- Widgets -->
    </ais-instantsearch>
  `,
})
export class AppComponent {
  config = {
    // ...
    initialUiState: {
      YourIndexName: {
        query: 'phone',
        page: 5,
      },
    },
  }
}

onStateChange

Optional
Type: function

Triggers when the state changes. This can be useful when performing custom logic on a state change.

When using on-state-change, the instance is under your control. You’re responsible for updating the UI state (with setUiState).

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
@Component({
  template: `
    <ais-instantsearch [config]="config">
      <!-- Widgets -->
    </ais-instantsearch>
  `,
})
export class AppComponent {
  config = {
    // ...
    onStateChange({ uiState, setUiState }) {
      // Custom logic

      setUiState(uiState);
    },
  }
}

stalledSearchDelay

Optional
Type: number

A time period (in ms) after which the search is considered to have stalled. Read the slow network guide for more information.

1
2
3
4
5
6
7
8
9
10
11
12
13
@Component({
  template: `
    <ais-instantsearch [config]="config">
      <!-- Widgets -->
    </ais-instantsearch>
  `,
})
export class AppComponent {
  config = {
    // ...
    stalledSearchDelay: 500,
  }
}

routing

Optional
Type: boolean|object

The router configuration used to save the UI state into the URL or any client-side persistence. The object is accepted if it has either of these keys:

  • router: object: this object is the part that saves the UI state. By default, it uses an instance of the history-router with the default parameters. It accepts:
    • onUpdate: function: adds an event listener that makes InstantSearch aware of external changes to the storage medium (such as the URL). Typically you’ll set up a listener for popstate, which triggers a callback with the current routeState.
    • read: function: reads the routing storage and gets routeState. It doesn’t take any parameters but returns an object.
    • write: function: pushes routeState into routing storage.
    • createURL: function: transforms routeState into a URL. It receives an object and returns a string (which may be empty).
    • dispose: function: cleans up all event listeners.
  • stateMapping: object: transforms the ui-state into the object saved by the router. The default value is provided by simple-state-mapping. It accepts:
    • stateToRoute: function: transforms a ui-state representation into routeState. It receives an object that contains the UI state of all the widgets on the page. It can return any object that is readable by routeToState.
    • routeToState: function: transforms routeState into a ui-state representation. It receives an object that contains the UI state stored by the router. It can return any object that is readable by stateToRoute.

For more information, read the routing guide.

1
2
3
4
5
6
7
8
9
10
11
12
13
@Component({
  template: `
    <ais-instantsearch [config]="config">
      <!-- Widgets -->
    </ais-instantsearch>
  `,
})
export class AppComponent {
  config = {
    // ...
    routing: true,
  }
}

insightsClient

Optional
Type: function

This function is exposed by the search-insights library (usually window.aa) and is required if you want to send click and conversion events with InstantSearch.

1
2
3
4
5
6
7
8
9
10
11
12
13
@Component({
  template: `
    <ais-instantsearch [config]="config">
      <!-- Widgets -->
    </ais-instantsearch>
  `,
})
export class AppComponent {
  config = {
    // ...
    insightsClient: (window as any).aa,
  }
}

Skip to main content
Signature
<ais-instant-search
  index-name="string"
  :search-client="object"
  // Optional parameters
  :on-state-change="function"
  :search-function="function"
  :stalled-search-delay="number"
  :routing="object"
  :initial-ui-state="object"
  :class-names="object"
  :insights="boolean | object"
  :insights-client="function"
  :future="{
    preserveSharedStateOnUnmount: boolean,
    persistHierarchicalRootCount: boolean,
  }"
/>

Import

You can import this widget in two ways.
To ensure optimal bundle sizes, see Optimize build size.
Vue
import { AisInstantSearch } from "vue-instantsearch";
// Use "vue-instantsearch/vue3/es" for Vue 3

export default {
  components: {
    AisInstantSearch,
  },
  // ...
};

See this widget in action

Preview this widget and its behavior.

About this widget

ais-instant-search is the root wrapper component for all widgets.

Middleware

Vue InstantSearch provides middleware to help you connect to other systems:

Examples

Vue
<template>
  <ais-instant-search
    index-name="INDEX_NAME"
    :search-client="searchClient"
  >
    <!-- Widgets -->
  </ais-instant-search>
</template>

<script>
import { liteClient as algoliasearch } from "algoliasearch/lite";

export default {
  data() {
    return {
      searchClient: algoliasearch("YourApplicationID", "YourSearchOnlyAPIKey"),
    };
  },
};
</script>

Props

index-name
string
required
The main in which to search.
Vue
<ais-instant-search
  [...]
  index-name="INDEX_NAME"
>
  <!-- Widgets -->
</ais-instant-search>
search-client
object
required
Provides a search client to ais-instant-search. Read the custom backend guidance on implementing a custom search client.The client uses a cache to avoid unnecessary search operations, so you should use a stable reference to the same search client instance rather than creating a new one on each render. Avoid inlining the function call to algoliasearch as the prop value in your Vue template.
Vue
<template>
  <ais-instant-search
    [...]
    :search-client="searchClient"
  >
    <!-- Widgets -->
  </ais-instant-search>
</template>

<script>
import { liteClient as algoliasearch } from "algoliasearch/lite";

export default {
  data() {
    return {
      searchClient: algoliasearch("YourApplicationID", "YourSearchOnlyAPIKey"),
    };
  },
};
</script>
search-function
function
This option lets you take control of search behavior. For example, to avoid doing searches at page load.When this option is set, search.helper won’t emit events. Instead, use onStateChange or widgets to handle search behavior.A hook is called for every (with Algolia’s search helper as a parameter). Begin searching by calling helper.search().When modifying the state of the helper within search-function, the helper resets the page to 0. To keep the current page, store the page information, modify the state, and reapply pagination.
<template>
  <ais-instant-search
    [...]
    :search-function="searchFunction"
  >
    <!-- Widgets -->
  </ais-instant-search>
</template>

<script>
export default {
  data() {
    return {
      // ...
      searchFunction(helper) {
        if (helper.state.query) {
          helper.search();
        }
      },
    };
  },
};
</script>
on-state-change
function
Triggers when the state changes. This can be useful when performing custom logic on a state change.When using on-state-change, the instance is under your control. You’re responsible for updating the UI state (with setUiState).
Vue
<template>
  <ais-instant-search
    [...]
    :on-state-change="onStateChange"
  >
    <!-- Widgets -->
  </ais-instant-search>
</template>

<script>
export default {
  data() {
    return {
      // ...
      onStateChange({ uiState, setUiState }) {
        // Custom logic

        setUiState(uiState);
      },
    };
  },
};
</script>
stalled-search-delay
number
default:200
A time period (in ms) after which the search is considered to have stalled. Read the slow network guide for more information.
Vue
<ais-instant-search
  [...]
  :stalled-search-delay="1000"
>
  <!-- Widgets -->
</ais-instant-search>
routing
boolean | object
default:false
The router configuration used to save the UI state into the URL or any client-side persistence.For more information, see Sync your URLs.You can’t use initialUiState with routing as the two options override each other.
  • Use initialUiState for simple and static use cases.
  • Use routing for anything complex or dynamic.
Vue
<template>
  <ais-instant-search
    [...]
    :routing="routing"
  >
    <!-- Widgets -->
  </ais-instant-search>
</template>

<script>
import { history } from "instantsearch.js/es/lib/routers";
import { simple } from "instantsearch.js/es/lib/stateMappings";

export default {
  data() {
    return {
      // ...
      routing: {
        router: history(),
        stateMapping: simple(),
      },
    };
  },
};
</script>
initial-ui-state
object
Adds a uiState to your ais-instant-search instance, which provides an initial state to your widgets.Replace YourIndexName with the name of your Algolia index.
Vue
<template>
  <ais-instant-search
    :initial-ui-state="initialUiState"
  ></ais-instant-search>
</template>

<script>
export default {
  data() {
    return {
      // ...
      initialUiState: {
        YourIndexName: {
          query: "phone",
          page: 5,
        },
      },
    };
  },
};
</script>
class-names
object
default:"{}"
The CSS classes you can override:
  • ais-InstantSearch: the root of the widget.
Vue
<ais-instant-search
  [...]
  :class-names="{
    'ais-InstantSearch': 'MyCustomInstantSearch',
  }"
>
  <!-- Widgets -->
</ais-instant-search>
insights
boolean | object
default:false
since: v4.9.0
Enables the Insights middleware and loads the search-insights library (if not already loaded). The Insights middleware sends view and click events automatically, and lets you set up your own click and conversion events. To use this option with an object, refer to the Insights middleware options.
<ais-instant-search
  [...]
  :insights="true"
>
  <!-- Widgets -->
</ais-instant-search>
insights-client
function
deprecated
Use insights instead.This function is exposed by the search-insights library (usually window.aa) and is required if you want to send click and conversion events with the insights middleware.
Vue
<template>
  <ais-instant-search
    [...]
    :insights-client="insightsClient"
  >
    <!-- Widgets -->
  </ais-instant-search>
</template>

<script>
export default {
  data() {
    return {
      // ...
      insightsClient: window.aa,
    };
  },
};
</script>
future
object
Test new InstantSearch features without affecting others.

HTML output

HTML
<div class="ais-InstantSearch">
  <!-- Widgets -->
</div>
Last modified on April 28, 2026